Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.0.3 generated on February 20 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## kodo.jdbc.meta
Class ClassMapping

    java.lang.Object
      |
      +--kodo.meta.DelegatingExtensions
            |
            +--kodo.meta.DelegatingClassMetaData
                  |
                  +--kodo.jdbc.meta.ClassMapping

All Implemented Interfaces:
  ClassMetaData, Comparable, Extensions, Mapping, com.solarmetric.meta.SourceTracker

Direct Known Subclasses:
  BaseClassMapping, FlatClassMapping, NoneClassMapping, VerticalClassMapping

public abstract class ClassMapping
extends DelegatingClassMetaData
implements Mapping

Mapping from a class to a relational schema.

In addition to the bean methods for simple metadata attributes, the following methods are available before `resolve()` has been called: `getDeclaredFieldMapping(int)`, `getDeclaredFieldMapping(String)`, `getDeclaredFieldMappings()`. If the superclass mapping has been set or if this is a base class, then `getPrimaryKeyFieldMappings()` and `getPrimaryKeyColumns()` are also available before resolve.

Field Summary
`static String` | `AUTO_INCREMENT` Extension indicating that this data store identity class has an auto-incrementing primary key column.
`static String` | `CLASS_IND` Extension key used to indicate the type of class indicator to use, or "none" for none.
`static String` | `CLASS_INDEXED` Whether the class indicator is indexed.
`static String` | `CLASS_MAP` Extension key used to indicate the type of class mapping to use.
`static String` | `REF_DELETE_ACTION` Extension key used to mark the foreign key delete action on vertically- mapped tables.
`static String` | `SEQUENCE_FACTORY` Extension key used to indicate the sequence factory for this persistent type.
`static String` | `VERSION_IND` Extension key used to indicate the type of version indicator to use, or "none" for none.
`static String` | `VERSION_INDEXED` Whether the version indicator is indexed.

Fields inherited from interface kodo.meta.ClassMetaData
`DATA_CACHE, DATA_CACHE_TIMEOUT, DETACH_OID_FIELD, DETACH_STATE_FIELD, DETACHABLE, ID_APPLICATION, ID_DATASTORE, ID_NONDURABLE, VALIDATE_ALL, VALIDATE_NONE, VALIDATE_NORESOLVE, VALIDATE_RUNTIME, VALIDATE_UNENHANCED`

Constructor Summary
`ClassMapping(ClassMetaData meta)` Constructor.

Method Summary
`void` | `addDeclaredField(FieldMetaData field)` Add a persistent or transactional field to this class.
`protected void` | `assertResolved()` Throw an exception if this mapping has not been resolved.
`void` | `delete(KodoStateManager sm, JDBCStoreManager store)` Override this method to customize flushing this mapping.
`abstract ClassIndicator` | `getClassIndicator()` Return the class indicator for this class.
`int` | `getClassIndicatorIndexed()`
`String` | `getClassIndicatorName()`
`String` | `getClassMappingName()`
`Object` | `getDataStoreValue(Object obj, Column[] cols)` Return the given column value(s) for the given object.
`protected DBDictionary` | `getDBDictionary()` Return the dictionary to use.
`FieldMetaData` | `getDeclaredField(int index)` Return the metadata for the persistent or transactional field with the given relative index.
`FieldMetaData` | `getDeclaredField(String name)` Return the metadata for the persistent or transactional field with the given name, without including superclass fields.
`FieldMapping` | `getDeclaredFieldMapping(int index)` Convenience method to make casting from `getDeclaredField(int)` unnecessary.
`FieldMapping` | `getDeclaredFieldMapping(String name)` Convenience method to make casting from `getField(int)` unnecessary.
`FieldMapping[]` | `getDeclaredFieldMappings()` Convenience method to make casting from `getDeclaredFields()` unnecessary.
`FieldMetaData[]` | `getDeclaredFields()` Return only the fields for this class, without superclass fields.
`FieldMapping[]` | `getDefaultFetchGroupFieldMappings()` Convenience method to make casting from `getDefaultFetchGroupFields()` unnecessary.
`FieldMetaData[]` | `getDefaultFetchGroupFields()` Return the list of fields in the default fetch group, including superclass fields, or an empty array if none.
`static ClassMapping[]` | `getDefaults()` Return the set of default mapping types.
`FieldMapping` | `getEmbeddingMapping()` If this is an embedded mapping, return the owning field.
`FieldMetaData` | `getField(int index)` Return the metadata for the persistent or transactional field with the given absolute index.
`FieldMetaData` | `getField(String name)` Return the metadata for the persistent or transactional field with the given name.
`FieldMapping` | `getFieldMapping(int index)` Convenience method to make casting from `getField(int)` unnecessary.
`FieldMapping` | `getFieldMapping(String name)` Convenience method to make casting from `getField(int)` unnecessary.
`FieldMapping[]` | `getFieldMappings()` Convenience method to make casting from `getFields()` unnecessary.
`FieldMetaData[]` | `getFields()` Return all field metadatas, including superclass fields.
`JoinableMapping` | `getJoinableMapping(Column col)` Return the joinable mapping for the given column.
`ClassMappingInfo` | `getMappingInfo()` Return the mapping info that was used to create this mapping, if any.
`MappingRepository` | `getMappingRepository()` Return the repository for this mapping.
`Object` | `getObjectId(Result res, ForeignKey fk)` Return the oid value stored in the result.
`ClassMapping[]` | `getPCSubclassMappings()` Convenience method to make casting from `getPCSubclassMetaDatas()` unnecessary.
`ClassMetaData[]` | `getPCSubclassMetaDatas()` Return the metadata for the known persistence capable subclasses of the described type, or empty array if none.
`ClassMapping` | `getPCSuperclassMapping()` Convenience method to make casting from `getPCSuperclassMetaData()` unnecessary.
`ClassMetaData` | `getPCSuperclassMetaData()` Return the metadata for the persistence capable superclass of the described type, or null if the metadata did not specify one.
`abstract Column[]` | `getPrimaryKeyColumns()` Return the columns this mapping uses to uniquely identify an object.
`FieldMapping[]` | `getPrimaryKeyFieldMappings()` Convenience method to make casting from `getPrimaryKeyFields()` unnecessary.
`FieldMetaData[]` | `getPrimaryKeyFields()` Return primary key fields, or empty array if none.
`int` | `getRefDeleteAction()`
`JDOMetaDataRepository` | `getRepository()` Return the owning repository.
`String` | `getSequenceFactory()`
`SequenceFactory` | `getSequenceFactoryInstance()` Return the sequence factory for this type, based on its sequence factory metadata extensions.
`abstract VersionIndicator` | `getVersionIndicator()` Return the version indicator for this class.
`int` | `getVersionIndicatorIndexed()`
`String` | `getVersionIndicatorName()`
`void` | `insert(KodoStateManager sm, JDBCStoreManager store)` Override this method to customize flushing this mapping.
`void` | `invalidateResolve()` For implementation use.
`boolean` | `isAutoIncrement()`
`Boolean` | `isCustomDelete(KodoStateManager sm)` Return `Boolean.FALSE` if this mapping does not customize the delete process, `Boolean.TRUE` if it does, or null if it does customize the delete, but also relies on the standard delete method being called.
`Boolean` | `isCustomInsert(KodoStateManager sm)` Return `Boolean.FALSE` if this mapping does not customize the insert process, `Boolean.TRUE` if it does, or null if it does customize the insert, but also relies on the standard insert method being called.
`Boolean` | `isCustomUpdate(KodoStateManager sm)` Return `Boolean.FALSE` if this mapping does not customize the update process, `Boolean.TRUE` if it does, or null if it does customize the update, but also relies on the standard update method being called.
`abstract boolean` | `isPrimaryKeyObjectId(boolean hasAll)` Return true if the this class' primary key columns correspond to the base class' primary key columns used to construct oid values.
`boolean` | `isRefDeleteActionDeferred()`
`boolean` | `isResolved()` For implementation use.
`abstract void` | `joinSuperclass(Joins joins)` Join the mapping to its superclass table.
`ResultObjectProvider` | `load(JDBCStoreManager store, boolean subclasses, JDBCFetchConfiguration fetch)` Override this method to customize obtaining a result containing all instances of this class.
`boolean` | `load(KodoStateManager sm, JDBCStoreManager store, JDBCFetchConfiguration fetch, Result result)` Override this method to customize loading a result into an instance.
`boolean` | `load(KodoStateManager sm, JDBCStoreManager store, JDOState state, JDBCFetchConfiguration fetch)` Override this method to load the state of a given object, returning true if this method handles the load.
`static ClassMapping` | `newInstance(String type, ClassMetaData meta)` Return the mapping for the given mapping type.
`boolean` | `removeDeclaredField(FieldMetaData field)` Remove the given field from management.
`void` | `resolve()` For implementation use.
`void` | `reverseMap(SchemaGroup schema, ReverseMappingTool tool)` Create mappings from the schema, using the given tool.
`void` | `setAutoIncrement(boolean autoInc)`
`void` | `setAutoIncrementValue(KodoStateManager sm, Column col, Connection conn)` Set the next auto increment value for the given column into the given instance.
`abstract void` | `setClassIndicator(ClassIndicator cls)` Set the class indicator for this class.
`void` | `setClassIndicatorIndexed(int idx)`
`void` | `setClassIndicatorName(String ind)`
`void` | `setClassMappingName(String map)`
`void` | `setMappingInfo(ClassMappingInfo info)` Set the mapping info that was used to create this class.
`void` | `setPCSuperclassMapping(ClassMapping superMapping)` Set the superclass mapping.
`void` | `setPCSuperclassMetaData(ClassMetaData meta)` Set the metadata for this class' superclass.
`void` | `setRefDeleteAction(int action, boolean deferred)`
`void` | `setRepository(JDOMetaDataRepository repos)` The supplied repository must be a `MappingRepository`.
`void` | `setSequenceFactory(String plugin)`
`abstract void` | `setVersionIndicator(VersionIndicator version)` Set the version indicator for this class.
`void` | `setVersionIndicatorIndexed(int idx)`
`void` | `setVersionIndicatorName(String ind)`
`void` | `update(KodoStateManager sm, JDBCStoreManager store)` Override this method to customize flushing this mapping.

Methods inherited from class kodo.meta.DelegatingClassMetaData
`compareTo, equals, getDataCache, getDataCacheName, getDataCacheTimeout, getDeclaredUnmanagedFields, getDelegate, getDescribedType, getDetachObjectId, getDetachObjectIdField, getDetachState, getDetachStateField, getIdentityType, getInnermostDelegate, getObjectIdClass, getPCSubclasses, getPCSuperclass, getPMClassLoader, getRequiresExtent, getSourceFile, getValidate, hashCode, isDetachable, isEnhanced, isInstanceCallbacks, setDataCacheName, setDataCacheTimeout, setDescribedType, setDetachable, setDetachObjectId, setDetachState, setIdentityType, setObjectIdClass, setPCSuperclass, setPMClassLoader, setRequiresExtent, setSourceFile, setValidate, toString`

Methods inherited from class kodo.meta.DelegatingExtensions
`addExtension, addExtension, getBooleanExtension, getBooleanExtension, getDoubleExtension, getDoubleExtension, getEmbeddedExtensions, getEmbeddedExtensions, getExtensionKeys, getExtensionKeys, getExtensionVendors, getIntExtension, getIntExtension, getObjectExtension, getObjectExtension, getStringExtension, getStringExtension, hasExtension, hasExtension, isEmpty, removeEmbeddedExtensions, removeEmbeddedExtensions, removeExtension, removeExtension`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface kodo.jdbc.meta.Mapping
`delete, fromMappingInfo, getMappingType, getTable, insert, map, refSchemaComponents, toMappingInfo, update`

Methods inherited from interface kodo.meta.Extensions
`addExtension, addExtension, getBooleanExtension, getBooleanExtension, getDoubleExtension, getDoubleExtension, getEmbeddedExtensions, getEmbeddedExtensions, getExtensionKeys, getExtensionKeys, getExtensionVendors, getIntExtension, getIntExtension, getObjectExtension, getObjectExtension, getStringExtension, getStringExtension, hasExtension, hasExtension, isEmpty, removeEmbeddedExtensions, removeEmbeddedExtensions, removeExtension, removeExtension`

Field Detail

### CLASS_MAP

    public static final String CLASS_MAP

  Extension key used to indicate the type of class mapping to use.

### VERSION_IND

    public static final String VERSION_IND

  Extension key used to indicate the type of version indicator to use, or "none" for none.

### CLASS_IND

    public static final String CLASS_IND

  Extension key used to indicate the type of class indicator to use, or "none" for none.

### VERSION_INDEXED

    public static final String VERSION_INDEXED

  Whether the version indicator is indexed. Defaults to true.

### CLASS_INDEXED

    public static final String CLASS_INDEXED

  Whether the class indicator is indexed. Defaults to true.

### REF_DELETE_ACTION

    public static final String REF_DELETE_ACTION

  Extension key used to mark the foreign key delete action on vertically- mapped tables. Legal values are `none`, `exception`, `exception-deferred`, `cascade`, `cascade-deferred`. Defaults to `none`.

### AUTO_INCREMENT

    public static final String AUTO_INCREMENT

  Extension indicating that this data store identity class has an auto-incrementing primary key column. For application identity, use this extension on the column's field. Legal values are true or false. Defaults to false.

### SEQUENCE_FACTORY

    public static final String SEQUENCE_FACTORY

  Extension key used to indicate the sequence factory for this persistent type. This extension is only valid in least-derived persistent classes.

Constructor Detail

### ClassMapping

    public ClassMapping(ClassMetaData meta)

  Constructor. Supply underlying metadata.

Method Detail

### newInstance

    public static ClassMapping newInstance(String type,
                                           ClassMetaData meta)

  Return the mapping for the given mapping type.

### getDefaults

    public static ClassMapping[] getDefaults()

  Return the set of default mapping types.

### getMappingRepository

    public MappingRepository getMappingRepository()

  Return the repository for this mapping.
  Specified by:
    `getMappingRepository` in interface `Mapping`

### getMappingInfo

    public ClassMappingInfo getMappingInfo()

  Return the mapping info that was used to create this mapping, if any.

### setMappingInfo

    public void setMappingInfo(ClassMappingInfo info)

  Set the mapping info that was used to create this class.

### getVersionIndicator

    public abstract VersionIndicator getVersionIndicator()

  Return the version indicator for this class. Subclass mappings should delegate this method to their superclass.

### setVersionIndicator

    public abstract void setVersionIndicator(VersionIndicator version)

  Set the version indicator for this class. Subclass mappings should delegate this method to their superclass.

### getClassIndicator

    public abstract ClassIndicator getClassIndicator()

  Return the class indicator for this class. Subclass mappings should delegate this method to their superclass.

### setClassIndicator

    public abstract void setClassIndicator(ClassIndicator cls)

  Set the class indicator for this class. Subclass mappings should delegate this method to their superclass.

### getEmbeddingMapping

    public FieldMapping getEmbeddingMapping()

  If this is an embedded mapping, return the owning field. Returns null by default.

### getJoinableMapping

    public JoinableMapping getJoinableMapping(Column col)

  Return the joinable mapping for the given column. Any column that another mapping joins to must be controlled by a joinable mapping, unless it is a datastore identity column. This base class takes care of caching joinable mappings for all fields, and detecting requests for the datastore identity column. Class mappings that must link to their superclass table will usually have additional joinable mappings for the columns used for linking.

### getPrimaryKeyColumns

    public abstract Column[] getPrimaryKeyColumns()

  Return the columns this mapping uses to uniquely identify an object. These will typically be the primary key columns or the columns this class uses to link to its superclass table. This method must be available before resolve.

### isPrimaryKeyObjectId

    public abstract boolean isPrimaryKeyObjectId(boolean hasAll)

  Return true if the this class' primary key columns correspond to the base class' primary key columns used to construct oid values. Base classes always return true. Classes that join to the base class table, though, may not always join using the same columns the base class uses for oid values, or may not use all the column. When performing a select, we will join down to the most-derived class that is identified by oid values. We cannot use non-primary key field values for joining during selects, because the field values to join on might be the ones we're trying to select! Similarly, we can only reconstruct oid values for selected object using classes whose primary keys store oid values.
  Parameters:
    `hasAll` - if true, there must be a primary key column for every base class primary key column; if false the primary key must only match a subset of the base class primary key columns

### getObjectId

    public Object getObjectId(Result res,
                              ForeignKey fk)
                       throws SQLException

  Return the oid value stored in the result. This implementation will recurse until it finds an ancestor class who uses oid values for its primary key.
  Parameters:
    `fk` - if non-null, use the local columns of the given foreign key in place of this class' primary key columns
  See Also:
    `isPrimaryKeyObjectId(boolean)`

### setAutoIncrementValue

    public void setAutoIncrementValue(KodoStateManager sm,
                                      Column col,
                                      Connection conn)
                               throws SQLException

  Set the next auto increment value for the given column into the given instance.

### reverseMap

    public void reverseMap(SchemaGroup schema,
                           ReverseMappingTool tool)

  Description copied from interface: `Mapping`
  Create mappings from the schema, using the given tool. Implement this method if you want the class mapping to be a candidate when reverse-mapping a schema to java classes. Note that this method will be invoked on a template instance, so you cannot rely on the metadata or owning repository being set.
  Specified by:
    `reverseMap` in interface `Mapping`

### getDataStoreValue

    public Object getDataStoreValue(Object obj,
                                    Column[] cols)

  Return the given column value(s) for the given object. The given columns will be primary key columns of this mapping, but may be in any order. If there is only one column, return its value. If there are multiple columns, return an object array of their values, in the same order the columns are given.

### joinSuperclass

    public abstract void joinSuperclass(Joins joins)

  Join the mapping to its superclass table.

### isCustomInsert

    public Boolean isCustomInsert(KodoStateManager sm)

  Description copied from interface: `Mapping`
  Return `Boolean.FALSE` if this mapping does not customize the insert process, `Boolean.TRUE` if it does, or null if it does customize the insert, but also relies on the standard insert method being called. Implement the `#insert(KodoStateManager,JDBCStoreManager,Connection)` method to implement the custom insertion behavior.
  Specified by:
    `isCustomInsert` in interface `Mapping`

### isCustomUpdate

    public Boolean isCustomUpdate(KodoStateManager sm)

  Description copied from interface: `Mapping`
  Return `Boolean.FALSE` if this mapping does not customize the update process, `Boolean.TRUE` if it does, or null if it does customize the update, but also relies on the standard update method being called. Implement the `#update(KodoStateManager,JDBCStoreManager,Connection)` method to override the default update behavior.
  Specified by:
    `isCustomUpdate` in interface `Mapping`

### isCustomDelete

    public Boolean isCustomDelete(KodoStateManager sm)

  Description copied from interface: `Mapping`
  Return `Boolean.FALSE` if this mapping does not customize the delete process, `Boolean.TRUE` if it does, or null if it does customize the delete, but also relies on the standard delete method being called. Implement the `#delete(KodoStateManager,JDBCStoreManager,Connection)` method to override the default deletion behavior.
  Specified by:
    `isCustomDelete` in interface `Mapping`

### insert

    public void insert(KodoStateManager sm,
                       JDBCStoreManager store)
                throws SQLException

  Description copied from interface: `Mapping`
  Override this method to customize flushing this mapping. For classes, this method must also flush all fields. For fields, this method is called after the owning object is inserted, so if this field is in a row with other fields, that row will already exist.
  Specified by:
    `insert` in interface `Mapping`

### update

    public void update(KodoStateManager sm,
                       JDBCStoreManager store)
                throws SQLException

  Description copied from interface: `Mapping`
  Override this method to customize flushing this mapping. For classes, this method must also flush all fields.
  Specified by:
    `update` in interface `Mapping`

### delete

    public void delete(KodoStateManager sm,
                       JDBCStoreManager store)
                throws SQLException

  Description copied from interface: `Mapping`
  Override this method to customize flushing this mapping. For classes, this method must also flush all fields. For fields, this method will be called after the owning object is deleted.
  Specified by:
    `delete` in interface `Mapping`

### load

    public ResultObjectProvider load(JDBCStoreManager store,
                                     boolean subclasses,
                                     JDBCFetchConfiguration fetch)
                              throws SQLException

  Override this method to customize obtaining a result containing all instances of this class. Returns null by default.

### load

    public boolean load(KodoStateManager sm,
                        JDBCStoreManager store,
                        JDOState state,
                        JDBCFetchConfiguration fetch)
                 throws SQLException,
                        ClassNotFoundException

  Override this method to load the state of a given object, returning true if this method handles the load. If the object does not exist in the data store, simply take no action on it (but still return true). Returns false by default.
  Parameters:
    `state` - if non-null, then you must initialize the state and persistent object of the given state manager (after determining the actual class of the object from the database, if there are possible persistent subclasses); initialization looks like this: `sm.initialize (ImplHelper.getJDOHelper ().newInstance (pcClass, sm, sm.getObjectId (false, false)), state);` , where the ImplHelper class is in the kodo.util package

### load

    public boolean load(KodoStateManager sm,
                        JDBCStoreManager store,
                        JDBCFetchConfiguration fetch,
                        Result result)
                 throws SQLException

  Override this method to customize loading a result into an instance. Return true if this mapping handles the load; false if normal loading should procede after calling this method. Returns false by default.

### getDBDictionary

    protected DBDictionary getDBDictionary()

  Return the dictionary to use.

### getClassMappingName

    public String getClassMappingName()

### setClassMappingName

    public void setClassMappingName(String map)

### getVersionIndicatorName

    public String getVersionIndicatorName()

### setVersionIndicatorName

    public void setVersionIndicatorName(String ind)

### getClassIndicatorName

    public String getClassIndicatorName()

### setClassIndicatorName

    public void setClassIndicatorName(String ind)

### getVersionIndicatorIndexed

    public int getVersionIndicatorIndexed()

### setVersionIndicatorIndexed

    public void setVersionIndicatorIndexed(int idx)

### getClassIndicatorIndexed

    public int getClassIndicatorIndexed()

### setClassIndicatorIndexed

    public void setClassIndicatorIndexed(int idx)

### getRefDeleteAction

    public int getRefDeleteAction()

### isRefDeleteActionDeferred

    public boolean isRefDeleteActionDeferred()

### setRefDeleteAction

    public void setRefDeleteAction(int action,
                                   boolean deferred)

### getSequenceFactory

    public String getSequenceFactory()

### setSequenceFactory

    public void setSequenceFactory(String plugin)

### getSequenceFactoryInstance

    public SequenceFactory getSequenceFactoryInstance()

  Return the sequence factory for this type, based on its sequence factory metadata extensions. If no extensions are present in this type's least-derived persistent superclass, then the default sequence factory in the global configuration will be returned.

### isAutoIncrement

    public boolean isAutoIncrement()

### setAutoIncrement

    public void setAutoIncrement(boolean autoInc)

### getRepository

    public JDOMetaDataRepository getRepository()

  Description copied from interface: `ClassMetaData`
  Return the owning repository.
  Overrides:
    `getRepository` in class `DelegatingClassMetaData`

### setRepository

    public void setRepository(JDOMetaDataRepository repos)

  The supplied repository must be a `MappingRepository`.
  Overrides:
    `setRepository` in class `DelegatingClassMetaData`

### getPCSuperclassMetaData

    public ClassMetaData getPCSuperclassMetaData()

  Description copied from interface: `ClassMetaData`
  Return the metadata for the persistence capable superclass of the described type, or null if the metadata did not specify one.
  Overrides:
    `getPCSuperclassMetaData` in class `DelegatingClassMetaData`

### getPCSuperclassMapping

    public ClassMapping getPCSuperclassMapping()

  Convenience method to make casting from `getPCSuperclassMetaData()` unnecessary.

### setPCSuperclassMetaData

    public void setPCSuperclassMetaData(ClassMetaData meta)

  Description copied from interface: `ClassMetaData`
  Set the metadata for this class' superclass.
  Overrides:
    `setPCSuperclassMetaData` in class `DelegatingClassMetaData`

### setPCSuperclassMapping

    public void setPCSuperclassMapping(ClassMapping superMapping)

  Set the superclass mapping. This is used before reading mappings from `ClassMappingInfo`s.

### getPCSubclassMetaDatas

    public ClassMetaData[] getPCSubclassMetaDatas()

  Description copied from interface: `ClassMetaData`
  Return the metadata for the known persistence capable subclasses of the described type, or empty array if none.
  Overrides:
    `getPCSubclassMetaDatas` in class `DelegatingClassMetaData`

### getPCSubclassMappings

    public ClassMapping[] getPCSubclassMappings()

  Convenience method to make casting from `getPCSubclassMetaDatas()` unnecessary.

### getFields

    public FieldMetaData[] getFields()

  Description copied from interface: `ClassMetaData`
  Return all field metadatas, including superclass fields.
  Overrides:
    `getFields` in class `DelegatingClassMetaData`

### getFieldMappings

    public FieldMapping[] getFieldMappings()

  Convenience method to make casting from `getFields()` unnecessary.

### getDeclaredFields

    public FieldMetaData[] getDeclaredFields()

  Description copied from interface: `ClassMetaData`
  Return only the fields for this class, without superclass fields.
  Overrides:
    `getDeclaredFields` in class `DelegatingClassMetaData`

### getDeclaredFieldMappings

    public FieldMapping[] getDeclaredFieldMappings()

  Convenience method to make casting from `getDeclaredFields()` unnecessary.

### getPrimaryKeyFields

    public FieldMetaData[] getPrimaryKeyFields()

  Description copied from interface: `ClassMetaData`
  Return primary key fields, or empty array if none.
  Overrides:
    `getPrimaryKeyFields` in class `DelegatingClassMetaData`

### getPrimaryKeyFieldMappings

    public FieldMapping[] getPrimaryKeyFieldMappings()

  Convenience method to make casting from `getPrimaryKeyFields()` unnecessary.

### getDefaultFetchGroupFields

    public FieldMetaData[] getDefaultFetchGroupFields()

  Description copied from interface: `ClassMetaData`
  Return the list of fields in the default fetch group, including superclass fields, or an empty array if none.
  Overrides:
    `getDefaultFetchGroupFields` in class `DelegatingClassMetaData`

### getDefaultFetchGroupFieldMappings

    public FieldMapping[] getDefaultFetchGroupFieldMappings()

  Convenience method to make casting from `getDefaultFetchGroupFields()` unnecessary.

### getField

    public FieldMetaData getField(int index)

  Description copied from interface: `ClassMetaData`
  Return the metadata for the persistent or transactional field with the given absolute index.
  Overrides:
    `getField` in class `DelegatingClassMetaData`
  Following copied from interface: `kodo.meta.ClassMetaData`
  Returns:
    the field's metadata, or null if not found

### getFieldMapping

    public FieldMapping getFieldMapping(int index)

  Convenience method to make casting from `getField(int)` unnecessary.

### getDeclaredField

    public FieldMetaData getDeclaredField(int index)

  Description copied from interface: `ClassMetaData`
  Return the metadata for the persistent or transactional field with the given relative index.
  Overrides:
    `getDeclaredField` in class `DelegatingClassMetaData`
  Following copied from interface: `kodo.meta.ClassMetaData`
  Returns:
    the field's metadata, or null if not found

### getDeclaredFieldMapping

    public FieldMapping getDeclaredFieldMapping(int index)

  Convenience method to make casting from `getDeclaredField(int)` unnecessary.

### getField

    public FieldMetaData getField(String name)

  Description copied from interface: `ClassMetaData`
  Return the metadata for the persistent or transactional field with the given name. This method can only be used at runtime.
  Overrides:
    `getField` in class `DelegatingClassMetaData`
  Following copied from interface: `kodo.meta.ClassMetaData`
  Returns:
    the field's metadata, or null if not found

### getFieldMapping

    public FieldMapping getFieldMapping(String name)

  Convenience method to make casting from `getField(int)` unnecessary.

### getDeclaredField

    public FieldMetaData getDeclaredField(String name)

  Description copied from interface: `ClassMetaData`
  Return the metadata for the persistent or transactional field with the given name, without including superclass fields.
  Overrides:
    `getDeclaredField` in class `DelegatingClassMetaData`
  Following copied from interface: `kodo.meta.ClassMetaData`
  Returns:
    the field's metadata, or null if not found

### getDeclaredFieldMapping

    public FieldMapping getDeclaredFieldMapping(String name)

  Convenience method to make casting from `getField(int)` unnecessary.

### addDeclaredField

    public void addDeclaredField(FieldMetaData field)

  Description copied from interface: `ClassMetaData`
  Add a persistent or transactional field to this class.
  Overrides:
    `addDeclaredField` in class `DelegatingClassMetaData`

### removeDeclaredField

    public boolean removeDeclaredField(FieldMetaData field)

  Description copied from interface: `ClassMetaData`
  Remove the given field from management.
  Overrides:
    `removeDeclaredField` in class `DelegatingClassMetaData`
  Following copied from interface: `kodo.meta.ClassMetaData`
  Returns:
    true if the field was removed, false otherwise

### isResolved

    public boolean isResolved()

  Description copied from interface: `ClassMetaData`
  For implementation use. Return whether this metadata has been resolved.
  Overrides:
    `isResolved` in class `DelegatingClassMetaData`

### invalidateResolve

    public void invalidateResolve()

  Description copied from interface: `ClassMetaData`
  For implementation use. Invalidate resolved data.
  Overrides:
    `invalidateResolve` in class `DelegatingClassMetaData`

### resolve

    public void resolve()

  Description copied from interface: `ClassMetaData`
  For implementation use. This method resolves superclass information, caches fields, and resolves fields that might be other first class objects. It requires access to a respository. It can access other class metadata through the repository, but cannot access field metadata for those classes. It can, however, access superclass field metadata.
  Overrides:
    `resolve` in class `DelegatingClassMetaData`

### assertResolved

    protected void assertResolved()

  Throw an exception if this mapping has not been resolved.

Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.0.3 generated on February 20 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2001,2002 SolarMetric, Inc. All Rights Reserved.